System.register(["cc", "cc/env"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _decorator, Component, _cc, ResolutionPolicy, DEBUG, BaseUI, _dec, _class, _crd, cc, ccclass, property, RotateScreen;

  return {
    setters: [function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _decorator = _cc2._decorator;
      Component = _cc2.Component;
      _cc = _cc2;
      ResolutionPolicy = _cc2.ResolutionPolicy;
    }, function (_ccEnv) {
      DEBUG = _ccEnv.DEBUG;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "58e81+9HrVKDKCkyPtO8yQC", "RotateScreen", undefined);

      __checkObsolete__(['_decorator', 'Component', 'Node']);

      cc = __checkObsoleteInNamespace__(_cc);

      __checkObsolete__(['ResolutionPolicy']);

      ({
        ccclass,
        property
      } = _decorator);
      BaseUI = class BaseUI extends Component {
        onLoad() {
          let safeArea = this.node.getComponent(cc.SafeArea);

          if (!safeArea) {
            safeArea = this.node.addComponent(cc.SafeArea);
            safeArea.symmetric = false; //设置是否对称

            safeArea.updateArea();
          }
        }

        static async loadGroup(name) {
          return new Promise((resolve, reject) => {
            let bundle = cc.assetManager.getBundle(name);
            if (bundle) return resolve(bundle);
            cc.assetManager.loadBundle(name, (err, loadedBundle) => {
              if (err) {
                reject(err);
              } else {
                resolve(loadedBundle);
              }
            });
          });
        }

        static load(path, loadFiles, jsClass, value, bundle) {
          if (path.indexOf("|") > 0) {
            //路径带了包名，需要提取包名，优先加载包
            var bundleName = path.split("|")[0];
            loadFiles = loadFiles || [];

            if (loadFiles.indexOf(bundleName) < 0) {
              loadFiles.push(bundleName);
            }
          }

          if (loadFiles && loadFiles.length) {
            BaseUI.loadGroup(loadFiles[0]).then(bundle => {
              BaseUI._load(path, null, jsClass, value, bundle);
            });
            return;
          }

          BaseUI._load(path, null, jsClass, value, bundle);
        }

        static _load(path, loadFiles, jsClass, value, bundle) {
          if (DEBUG && value && value.funArgs && (typeof value.funArgs != "object" || !value.funArgs.indexOf)) {
            console.error("传入的参数无效，值必须是数组");
          }

          let paths = path.split("|"); //提取包名

          if (!bundle) {
            var bundleName = paths.length > 1 ? paths[0] : "skin";
            bundle = cc.assetManager.getBundle(bundleName);
          }

          let skinSrc = paths.pop(); //去掉包名的路径

          let skin = skinSrc.split("/").pop();

          let callBack = (err, prefab) => {
            if (err) {
              console.error(err);
              return;
            }

            var uiNode = cc.instantiate(prefab);
            let baseUI;

            if (jsClass) {
              baseUI = uiNode.addComponent(jsClass);

              if (!window[jsClass.name]) {
                window[jsClass.name] = jsClass; //window['xxxx]赋值
              }

              uiNode["script"] = baseUI;
            } else {
              if (DEBUG) console.warn("未设置jsClass，请检查是否在皮肤里面绑定script");

              for (var i = 0; i < uiNode.components.length; i++) {
                let item = uiNode.components[i];

                if (item instanceof BaseUI) {
                  uiNode["script"] = item;
                  break;
                }
              }

              baseUI = uiNode["script"];
            } // baseUI.skinName = skin;
            // if(value && value.funArgs){
            //     baseUI._arguments = value.funArgs;
            // }


            baseUI.showFun(uiNode);
          };

          if (bundle) {
            bundle.load(skinSrc, cc.Prefab, callBack);
            return;
          }

          cc.resources.load(skinSrc, callBack);
        }

        showFun(uiNode) {
          var container = cc.director.getScene().children[0];
          container.addChild(uiNode);
        }

      };

      _export("RotateScreen", RotateScreen = (_dec = ccclass('RotateScreen'), _dec(_class = class RotateScreen extends cc.Component {
        constructor(...args) {
          super(...args);
          this.isChanging = void 0;
        }

        onLoad() {
          this.setScaleMode();
          cc.screen.on('window-resize', (width, height) => {
            console.warn('window-resize', width, height);
            this.setScaleMode();
          }, this);
          let btn = cc.find("Canvas/ScrollView/view/content/btn/Button");
          btn.on(cc.Node.EventType.TOUCH_END, () => {
            BaseUI.load("skin|ListSkin", null, BaseUI);
          }, this);
        }

        setScaleMode() {
          cc.log("setScaleMode-ORIENTATION_CHANGE");
          if (this.isChanging) return;
          this.isChanging = true;
          let designSize = cc.view.getDesignResolutionSize();
          let max = Math.max(designSize.width, designSize.height);
          let min = Math.min(designSize.width, designSize.height);
          let nowOri = cc.view.getResolutionPolicy().getContentStrategy().strategy;
          let change = false;

          if (cc.screen.windowSize.width > cc.screen.windowSize.height) {
            //横屏
            if (nowOri != ResolutionPolicy.FIXED_HEIGHT) {
              change = true;
              cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
              cc.view.setDesignResolutionSize(max, min, ResolutionPolicy.FIXED_HEIGHT);
            }
          } else {
            if (nowOri != ResolutionPolicy.FIXED_WIDTH) {
              change = true;
              cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
              cc.view.setDesignResolutionSize(min, max, ResolutionPolicy.FIXED_WIDTH);
            }
          }

          if (change) {
            const size = cc.view.getVisibleSize();
            cc.screen.windowSize = new cc.Size(cc.screen.windowSize.width, cc.screen.windowSize.height);
            setTimeout(() => {
              window.dispatchEvent(new Event('resize'));
            }, 16);
          }

          this.isChanging = false;
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=3420bb67b56c890256a7e2e6bc70e06edf78a19f.js.map